/*
 * sx127x.h
 *
 *  Created on: Mar 4, 2023
 *  Author: Daniel Peter Chokola
 */

#ifndef SX127X_INC_SX127X_H_
#define SX127X_INC_SX127X_H_

/* Includes */
#include <stdint.h>
#include "spi.h"

/* Definitions */

/* Data Structures */
typedef struct sx127x_s {
	SPI_HandleTypeDef *hspi;
	GPIO_TypeDef *port;
	uint16_t pin;
	union __attribute__((packed, aligned(1))) sx127x_ver_u {
		uint8_t byte;
		struct __attribute__((packed, aligned(1))) sx127x_ver_s {
			uint8_t maskrev:4;
			uint8_t fullrev:4;
		} field;
	} ver;
} sx127x_t;

/* Function Prototypes */
int32_t sx127x_init(sx127x_t *sx127x, SPI_HandleTypeDef *hspi, GPIO_TypeDef *port, uint16_t pin);
int32_t sx127x_tx(sx127x_t *sx127x, uint8_t *buf, uint16_t len);
int32_t sx127x_rx(sx127x_t *sx127x, uint8_t *buf);
int32_t sx127x_snr(sx127x_t *sx127x);
int32_t sx127x_rssi(sx127x_t *sx127x);
int32_t sx127x_rand(sx127x_t *sx127x);
int32_t sx127x_txdone(sx127x_t *sx127x);

#endif /* SX127X_INC_SX127X_H_ */
